          #include <P16F628A.INC>
            LIST        p=16F628A     
            __CONFIG    H'3F18'        
                                     
            
Sec           equ         20h               ;   
Sec1          equ         21h               ;   
nomer         equ         22h               ;
scetbit       equ         23h               ;
perem         equ         24h               ;
var           equ         25h               ;
desiat        equ         26h               ;
shet          equ         27h               ;
priem         equ         28h               ;
sotni         equ         29h               ;
edin          equ         2Ah               ;
reg           equ         2Bh               ;
flag          equ         2Ch               ;
W_TEMP        equ         7Eh               ;
STATUS_TEMP   equ         7Fh               ;

#DEFINE       knp1  	  PORTA,2           ;   -
#DEFINE       clk   	  PORTA,7           ;
#DEFINE       datax  	  PORTA,0           ;
#DEFINE       cs  	      PORTA,1           ;
#DEFINE       led4   	  PORTB,4           ;
#DEFINE       led3  	  PORTB,5           ;
#DEFINE       led2  	  PORTB,6           ;
#DEFINE       led1  	  PORTB,7           ;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  USART
;   4 ,   1 

              org         0000h             ;     0000h
              goto        Start             ;   Start
           
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  

              org         0004h             ;     0004h
       
              movwf       W_TEMP            ;   
              swapf       STATUS,W          ;
              clrf        STATUS            ;
              movwf       STATUS_TEMP       ;
                 
              movf        RCREG,W           ;    USART  
              movwf       priem             ;  RCREG    
                                            ;priem
              bsf         flag,0            ;    (0- 
                                            ; flag)
             
              swapf       STATUS_TEMP,W     ;   
              movwf       STATUS            ;
              swapf       W_TEMP,F          ;
              swapf       W_TEMP,W          ;
                                            ;
              retfie                        ;    

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 
                                             
Start         clrf        PORTB             ;    A  B
              clrf        PORTA             ; 
              
              movlw       b'00000111'       ; 
              movwf       CMCON

              bsf         STATUS,RP0        ; 1-     
              movlw       b'00001111'       ;  \  B      
              movwf       TRISB             ;RB0,RB1,RB2,RB3 -  ,   
 
              movlw       b'01111100'       ;  \  A   
              movwf       TRISA             ;RA0,RA1,RA7 -  ,   
             
              movlw       0x19              ;  0x19   SPBRG    
              movwf       SPBRG             ;  USART,    
                                            ;  4   9600 /

              movlw       b'00100100'       ;  USART:   
              movwf       TXSTA             ;  USART,
                                            ;   USART: 8- 
                                            ;,                             
              bcf         STATUS,RP0        ; 0-  
                                            
              movlw       b'10010000'       ;  USART:   USART
              movwf       RCSTA             ;   USART: 8- 
                                            ;,  
                     
              clrf        flag              ;  flag    
              
              
              bsf         STATUS,RP0        ; 1-  
              bsf         PIE1,RCIE         ;    USART
              bcf         STATUS,RP0        ; 0- 
              bsf         INTCON,PEIE       ;   
              bsf         INTCON,GIE        ;  

              

osnova        bcf         cs          ; 3-    
              movlw       .0
              call        send
              movlw       .0
              call        send
              movlw       .0
              call        send
              bsf         cs
              nop
              nop
              bcf         cs          ; 
              movlw       .1
              call        send
              bsf         cs
      
oproskn1      btfsc       knp1              ;  knp1
              goto        dalee1            ;  :    dalee1
kn1           call        pausknp           ;      USART
              btfss       knp1              ; :    message
              goto        kn1               ;    USART
              call        message           ;

dalee1        btfsc      flag,0             ;     USART
              goto       priemviv           ; :    priemviv
              call       pausknp            ;  :   
              goto       oproskn1           ;   oproskn1,   

priemviv      movf       priem,W            ;    priem  
              movwf      var                ;var,   
              call       svet               ;   
              call       vivod              ;    
                                            ;var   
              bcf        flag,0             ;   
              goto       oproskn1           ;   oproskn1,   
              
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  

svet          movlw      .49                ;   var  
              xorwf      var,W              ; 49 (ASCII   1)
              btfss      STATUS,Z           ;
              goto       l1                 ; :    l1 
              bsf        led1               ; :   led1
              bcf        led2               ; 
              bcf        led3               ;
              bcf        led4               ;
              return                        ;  
l1            movlw      .50                ;   var  
              xorwf      var,W              ; 50 (ASCII   2)
              btfss      STATUS,Z           ;
              goto       l2                 ; :    l2
              bcf        led1               ; :   led2
              bsf        led2               ; 
              bcf        led3               ;
              bcf        led4               ;
              return                        ;  
l2            movlw      .51                ;   var  
              xorwf      var,W              ; 51 (ASCII   3)
              btfss      STATUS,Z           ;
              goto       l3                 ; :    l3
              bcf        led1               ; :   led3
              bcf        led2               ; 
              bsf        led3               ;
              bcf        led4               ;
              return                        ;  
l3            movlw      .52                ;   var  
              xorwf      var,W              ; 52 (ASCII   4)
              btfss      STATUS,Z           ;
              goto       l4                 ; :    l4
              bcf        led1               ; :   led4
              bcf        led2               ; 
              bcf        led3               ;
              bsf        led4               ;
              return                        ;  
l4            bcf        led1               ;   49,50,51,52
              bcf        led2               ;  
              bcf        led3               ;
              bcf        led4               ;
              return                        ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       USART
              
message       clrf       nomer              ;  nomer ( )
a2            call       table              ;   
              movwf      TXREG              ;      
              bsf        STATUS,RP0         ;   USART
a1            btfss      TXSTA,TRMT         ;  TRMT    
              goto       a1                 ; USART
              bcf        STATUS,RP0           
 
              incf       nomer,F            ;  nomer ( )
                                            ;      
                                            ;
              movlw      .10                ;   nomer  
              xorwf      nomer,W            ;  10
              btfss      STATUS,Z           ;
              goto       a2                 ; :    a2
              return                        ; :   
                                            ;     

table         movlw       high tab          ;    
              movwf       PCLATH            ;
              movf        nomer,W           ;
              addlw       low tab           ;
              btfsc       STATUS,C          ;
              incf        PCLATH,F          ;
              movf        nomer,W           ;
              addwf       PCL,F             ;
 
tab           dt 'P', 'I', 'C', ' ', 'A';   ;   
              dt 'l', 'i', 'v', 'e', ' ';   ;
              

            



vivod       clrf        sotni
pr0         incf        sotni,F ; 
            movlw       .100
            subwf       var,F
            btfsc       STATUS,C
            goto        pr0
            decf        sotni,F
            movlw       .100
            addwf       var,F
            clrf        desiat
pr1         incf        desiat,F ; 
            movlw       .10
            subwf       var,F
            btfsc       STATUS,C
            goto        pr1
            decf        desiat,F
            movlw       .10
            addwf       var,F
            clrf        edin
pr2         incf        edin,F ; 
            movlw       .1
            subwf       var,F
            btfsc       STATUS,C
            goto        pr2
            decf        edin,F

            
            
            clrf       reg

dalee        swapf       sotni,F
             movlw       .4
             movwf       var
             bcf         STATUS,C
a5           rlf         sotni,F
             rlf         reg,F
             decfsz      var,F
             goto        a5

             swapf       edin,F
             movlw       .4
             movwf       var
             bcf         STATUS,C
a6           rlf         edin,F
             rlf         desiat,F
             decfsz      var,F
             goto        a6
 
             bcf         cs          ; 3-    
             movlw       .0
             call        send
             movf        reg,W
             call        send
             movf        desiat,W
             call        send
             bsf         cs
             
             return



send         movwf      perem
             movlw      .8
             movwf      scetbit
povtor       bcf        clk
             btfsc      perem,7
             bsf        datax
             btfss      perem,7
             bcf        datax
             bsf        clk
             rlf        perem,F
             decfsz     scetbit,F
             goto       povtor
             bcf        clk
             return
        

pausknp       movlw       .20             ; 15 
              movwf       Sec1
p3            movlw       .255
              movwf       Sec             ;
p2            decfsz      Sec,F           ;
              goto        p2              ;
              decfsz      Sec1,F          ;
              goto        p3              ;
              return                      ;
                                          ;
              end                         ;  